		.TITLE	"+3 CARGA Y EJECUCION DE SNAPS Z80"

; (CopyLeft) 1999 DJr.

; ENSAMBLAR CON TASM - OPCIONES "-80 -l -f00 -g3"
;

;#DEFINE DEBUG				;SI DEF ==> MUESTRA MEM. LIBRE

;#DEFINE INGLES				;SI LA ETIQUETA INGLES EXISTE ENTONCES 
					;TASM ENSAMBLA CON MENSAJES EN INGLES

#DEFINE IN_MF3	IN A,($3F)		;PAGE IN ROM_MF3 + RAM 8KB
#DEFINE OUT_MF3	IN A,($BF)		;PAGE OUT ROM_MF3 + RAM 8KB

		.ORG	$7000

		JR	START
		
USR0:		.DB	%00110000	;SI QUEREMOS QUE UN SNAP 48K ARRANQUE
					;EN MODALIDAD "USR 0" DEBEMOS POKEAR
					;AQUI EL VALOR 10h DE LO CONTRARIO SI
					;QUEREMOS BLOQUEAR LA PAGINACION USAMOS
					;EL VALOR 30h O SEA DIR DE CARGA+3
					
START:		DI			;MODIFICACION (HECHA EN 2002)
		LD	HL,$2000	;AVERIGUA SI HAY UN MF3
		IN_MF3			;EN ESE CASO SE USA "SU"
		LD	(HL),$FF	;MEMORIA PARA RECUPERAR
		LD	E,(HL)		;"TODA" LA PANTALLA EN CASO
		OUT_MF3			;DE CARGARSE UN Z80 128K
		LD	A,E
		CP	$FF
		JR	NZ,NO_MF3
		LD	(MF3),A		;MF3 QUEDA VALIENDO 0 SI NO HAY MF3

NO_MF3:		EI
		LD	SP,CATBUFFER - 1
		LD	A,(FLAGS3)
		BIT	5,A
		JR	NZ,B_PRESENTE
		LD	HL,NUEVO_MAPB	;PONE RUTINA PARA CAMBIO
		LD	C,$00		;DE DISKETTE A:->B:
		LD	IY,DOS_MAP_B
		CALL	P3DOS

B_PRESENTE:	XOR	A		;DESACTIVA RUTINA ALERT DEL P3DOS
		LD	HL,$0000
		LD	IY,DOS_SET_ALERT
		CALL	P3DOS

		CALL	BUSC_POKES	;MIRA SI HAY POKES (DIM P(...))
		CALL	BUSC_VAR_A	;BUSCA A$
		JR	Z,OK_NAME_A
		CALL	SELEC_ARCH	;SI NO EXISTE DEJA QUE EL USUARIO
		JR	Z,OK_NAME	;SELECCIONE EL ARCHIVO
		RST	08H		;SI 'Z' i.e. cancelado por el usuario
		.DB	$FF		;entonces termina. ("0 OK, 0:1")

OK_NAME:	CALL	EXSOUND3
OK_NAME_A:	LD	A,$07		;prepara el programa de carga del Z80
		LD	(23693),A
		LD	(BORDCR),A
		XOR	A
		OUT	($FE),A

		LD	HL,$4000	;borra la pantalla
		LD	DE,$4001
		LD	BC,$1AFF
		LD	(HL),L
		LDIR
		LD	HL,LOADER	;copia el programa cargador en la
		LD	DE,$4000	;pantalla
		LD	BC,$0800	;(un tercio)
		LDIR
		LD	HL,POKES
		LD	DE,POKES+1
		LD	BC,$47FF-POKES-1
		LD	(HL),$00
		LDIR

		LD	HL,$5AC0	;las dos ultimas lineas de la pantalla
		LD	DE,$5AC1	;quedan con paper 0, ink 7, por si
		LD	(HL),$07	;NUEVO_MAPB necesita imprimir algo.
		LD	BC,63
		LDIR
		LD	IX,ATTRS	;descomprime los attrs. para...
		LD	HL,$B000
		LD	DE,179
		CALL	UNCOMPRESS2
		LD	HL,$B000	;...ocultar el programa en pantalla
		LD	DE,$5800	;asi por lo menos queda ms bonito
		LD	BC,$100
		LDIR

		LD	HL,$5008	;imprime el LOGO en 5008h
		LD	(DSF_DIR+1),HL
		CALL	PR_LOGO

		LD	A,(MF3)		;recupera la variable MF3
		LD	(MULTIFACE3),A

		CALL	OPENFILE	;abre el archivo, prepara +3DOS,
					;y averigua la versin del archivo
					;adems imprime tipo de SNAP

		LD	HL,CANT_POKES	;si habian POKES los copia en la
		LD	DE,POKES	;pantalla por que si no podriamos
		LD	BC,31		;encontrarlos
		LDIR

		LD	A,(TIPOSNAP)
		AND	A
		JR	Z,RUN_SNAP48K

RUN_SNAP128K:	LD	HL,PATRON_128	;Copiamos la rutina para carga
		LD	DE,SNAP128K	;de SNAPs 128K,+2,+3,etc
		CALL	JUMPBOOT
		JR	START_LOAD

RUN_SNAP48K:	LD	HL,PATRON_48	;Copiamos la rutina para carga
		LD	DE,SNAP48K	;de SNAPs 48K
		CALL	JUMPBOOT
		LD	A,(USR0)
		LD	(REG_LATCH+1),A
		JR	START_LOAD

JUMPBOOT:	DI
		LD	(PUENTE+1),DE

		LD	IX,LOADER
		CALL	BUSCAR_STRING
		LD	HL,(BUSC_RUT)
		LD	(START_RUT+1),HL
		PUSH	HL
		POP	IX
		LD	HL,PATRON_FIN
		CALL	BUSCAR_STRING
		LD	BC,(START_RUT+1)
		LD	HL,(BUSC_RUT)
		AND	A
		SBC	HL,BC
		LD	(TAM_RUT+1),HL
		LD	BC,BOOTEADOR
		ADD	HL,BC
		LD	A,H
		CP	$48
		JR	NC,ERR_TAMPROG
		CP	$47
		JR	NZ,START_RUT
		LD	A,L
		CP	$FF
		JR	NZ,START_RUT
ERR_TAMPROG:	LD	A,0
		CALL	PRINT_MENERR
		JP	BLOQUEO

START_RUT:	LD	HL,$0000
		PUSH	HL
		LD	DE,BOOTEADOR
TAM_RUT:	LD	BC,$0000
		LDIR
		POP	HL
		RET

START_LOAD:	.EQU	$

#IFDEF DEBUG
		LD	HL,$47FF	;solo para propsitos de depuracin
		AND	A		;me muestra cuanta memoria libre
		SBC	HL,DE		;tengo en el primer tercio de pantalla
		PUSH	HL		;una vez descontado el tamao de la
		LD	A,2		;rutina cargadora SNAP128K o SNAP48K
		CALL	PRINT_MENERR
		POP	BC
		CALL	PRNUMERO
#ENDIF
		LD	SP,STACK
		CALL	SET_MYINT
		LD	A,$07
		LD	(BANKM),A
		LD	BC,PBANKM
		OUT	(C),A
PUENTE:		JP	$0000

BUSCAR_STRING:	LD	(BUSC_RUT),IX	;BUSCA A PARTIR DE (BUSC_RUT) UN STRING
		LD	(BUSC_DIR),HL	;DETERMINADO POR (BUSC_DIR)
LBUSC_BOOT:	LD	A,(HL)
		CP	$FF
		RET	Z
		CP	(IX)
		JR	NZ,NEXT_FBYTE
		INC	IX
		INC	HL
		JR	LBUSC_BOOT

NEXT_FBYTE:	INC	IX
		.DB	$DD
		LD	A,H
		AND	A
		JR	Z,NO_EXISTE
		LD	(BUSC_RUT),IX
		LD	HL,(BUSC_DIR)
		JR	LBUSC_BOOT
NO_EXISTE:	LD	A,1
		CALL	PRINT_MENERR
		JP	BLOQUEO

PATRON_128:	.DB	"SNAP128K",$FF
PATRON_48:	.DB	"SNAP48K",$FF
PATRON_FIN:	.DB	"END",$FF
BUSC_DIR:	.DW	$0000
BUSC_RUT:	.DW	$0000

; ==========================================================================
; PREPARA +3DOS, ABRE EL ARCHIVO, E IMPRIME NOMBRE Y TIPO DEL SNAP
OPENFILE:	LD	DE,$0000	;DESACTIVA CACHE Y RAMDISK
		LD	HL,$0000
		LD	IY,DOS_SET_1234
		CALL	P3DOS
		JP	NC,ERROR_7000H

		LD	DE,$0002	;abre el archivo con handle #06
		LD	BC,$0601
		LD	HL,FILENAME
		LD	A,(LODDRV)
		LD	(FILENAME),A
		LD	IY,OPEN
		CALL	P3DOS
		JP	NC,ERROR_7000H

CHECKFILE:	LD	HL,CATBUFFER	;carga la cabecera del Z80 y comienza
		LD	DE,56		;a averiguar el tipo de SNAP
		LD	BC,$0600
		LD	IY,READ
		CALL	P3DOS
		JP	NC,ERROR_7000H

		LD	IX,CATBUFFER
		LD	L,(IX+6)
		LD	H,(IX+7)
		LD	A,H
		OR	L
		JR	Z,NO_VER145	;si PC=0 entonces...

		LD	A,6		;es un Z80 V1.45 no
		CALL	PRINT_MENTBL	;se acepta
		JR	SNAPMAL

NO_VER145:	LD	A,(IX+34)	;VER AL PRINCIPIO POR IDs
		LD	(TIPOSNAP),A
		LD	HL,L48K
		CP	3
		JR	C,STPRINT	;ID < 3 ==> SNAP 48K

		LD	HL,L128K
		CP	7
		JR	C,STPRINT	;ID < 7 ==> SNAP 128K

		LD	HL,LPLUS3
		CP	7
		JR	Z,STPRINT	;ID = 7 == > SNAP +3 o +2A

		;CP	8
		;JR	Z,???????	;ID = 8 == > QUE SNAP SERA???????

		LD	HL,LPENTA
		CP	9
		JR	Z,STPRINT	;ID = 9 == > SNAP PENTAGON

		LD	A,6		;SI LLEGO ACA NO SE RECONOCIO
		CALL	PRINT_MENTBL	;EL SNAP (48K,128K,P3,PENTA)
		JR	SNAPMAL

STPRINT:	CALL	PRINT_MEN
		LD	HL,NOMBRE_DESCR
		LD	A,(NOMBRE_CORTO)
		CP	$01
		JR	NZ,NOMBRE_DESC
		INC	HL
NOMBRE_DESC:	CALL	PRINT_MEN
		LD	A,(TIPOSNAP)
		CP	3
		RET	C
		LD	A,(MF3)
		AND	A
		RET	Z
		LD	A,7
		JP	PRINT_MENTBL

SNAPMAL:	LD	B,$06		;NO quizo cargar el SNAP
		LD	IY,CLOSE	;cierra el archivo...
		CALL	P3DOS
		RST	08H
		.DB	$FF		;...y retorna al BASIC ("0 OK, 0:1")

; ==========================================================================

ERROR_7000H:	PUSH	AF		;control de errores +3DOS
		LD	HL,$4800
		LD	DE,$4801
		LD	BC,2047
		LD	(HL),$00
		LDIR
		LD	HL,MEN_ERR7000H
		CALL	PRINT_MEN
		POP	AF
		LD	C,A
		LD	B,$00
		CALL	PRNUMERO
		RST	08H
		.DB	$FF		;("0 OK, 0:1")

MEN_ERR7000H:	.DB	22,9,0,"+3DOS ERROR: ",$FF

; ==========================================================================
PRINT_MENERR:	LD	HL,DEV_MESS	;TABLA DE MENSAJES PROPIOS DE
		JR	MSGTBL		;DEPURACION
		
PRINT_MENTBL:	LD	HL,HARDMENS	;IMPRIME EL MENSAJE 'A' DE LA TABLA
MSGTBL:		CALL	BUSC_MEN	;'HARDMENS'

; ==========================================================================
PRINT_MEN:	PUSH	HL		;IMPRIME UN MENSAJE A PARTIR DE 'HL
		LD	A,$02		;QUE TERMINA EN FFh
		CALL	CHOPEN
		POP	HL
LPRINT_MEN:	LD	A,(HL)
		CP	$FF
		RET	Z
		CP	$FE		;CODIGO FEh ABRE EL CANAL #01
		JR	NZ,SIG_MEN
		PUSH	HL
		LD	A,$01
		CALL	CHOPEN
		POP	HL
		JR	NOPRINT
SIG_MEN:	CP	$80
		JR	C,OKPRINT
		PUSH	HL
		LD	HL,TOKEN
		RES	7,A
		CALL	BUSC_MEN
		CALL	LPRINT_MEN
		POP	HL
		JR	NOPRINT
OKPRINT:	RST	10H
NOPRINT:	INC	HL
		JR	LPRINT_MEN

; ===========================================================================
; Busca el mensaje 'A' en la tabla 'HL'. Cada mensaje debe estar separado por
; un FFh - Retorna en 'HL' la direccion del mensaje
;
BUSC_MEN:	AND	A
		RET	Z
		LD	B,A
		LD	A,$FF
LBUSC_MEN:	PUSH	BC
		LD	BC,$0000
		CPIR
		POP	BC
		DJNZ	LBUSC_MEN
		RET

; ==========================================================================
; ESTOS MENSAJES SON PARA DEPURACION - NO DEBERIAN VERSE NUNCA ;-)
DEV_MESS:	.DB	$FE,22,0,0				;0
		.TEXT	"PROGRAMA MUY GRANDE - NO ENTRA  "
		.TEXT	"EN EL PRIMER TERCIO             "
		.DB	$FF

		.DB	$FE,22,0,0				;1
		.TEXT	"ERROR NO PUEDO ENCONTRAR RUTINAS"
		.TEXT	"DE CARGA                        "
		.DB	$FF

		.DB	22,21,0,"LIBRE: "			;2
		.DB	$FF

; ==========================================================================

#IFDEF INGLES
;MENSAJES EN INGLES

HARDMENS:
L48K:		.DB	$80,"48K",$81,$FF			;0
L128K:		.DB	$80,"128K/+2",$81,$FF		;1
LPLUS3:		.DB	$80,"+3/+2A",$81,$FF			;2
LPENTA:		.DB	$80,"PENTAGON",$81,$FF			;3
UNKNOWN:	.DB	$80,"UNKNOWN",$81,$FF			;4

		.DB	$FE,22,0,0,"Insert disk for drive "	;5
DRIVEMAP:	.DB	"B"
		.DB	": then\rpress any key"
		.DB	$FF

		.DB	$80					;6
		.TEXT	"UNKNOWN Z80 TYPE\r"
		.DB	$FF

		.DB	$FE,22,1,0				;7
		.TEXT	"MF3 detected - Using MF3 RAM"
		.DB	$FF

TOKEN:		.DB	22,9,0,$FF				;0 ($80)
		.DB	" SNAP"					;1 ($81)
		.DB	$0D,$0D,"Loading: ",$FF	
#ELSE
;MENSAJES EN ESPAOL

HARDMENS:
L48K:		.DB	$80,"48K",$81,$FF			;0
L128K:		.DB	$80,"128K/+2",$81,$FF			;1
LPLUS3:		.DB	$80,"+3/+2A",$81,$FF			;2
LPENTA:		.DB	$80,"PENTAGON",$81,$FF			;3
UNKNOWN:	.DB	$80,"DESCONOCIDO",$81,$FF		;4

		.DB	$FE,22,0,0,"Inserte el disco para "	;5
DRIVEMAP:	.DB	"B"
		.DB	": y luegopresione una tecla."
		.DB	$FF

		.DB	22,9,0					;6
		.TEXT	"TIPO DE Z80 DESCONOCIDO"		;
		.DB	$FF
			;(este mensaje se puede mostrar tambin en caso de un
			;viejo Z80 V1.45)

		.DB	$FE,22,1,0				;7
		.TEXT	"MF3 detectado, usando su RAM"
		.DB	$FF

TOKEN:		.DB	22,9,0,"SNAP ",$FF			;0 ($80)
		.DB	$0D,$0D,"Cargando: ",$FF		;1 ($81)
#ENDIF

NOMBRE_CORTO:	.DB	$00
NOMBRE_DESCR:	.DB	$0D
NOMBRE8:	.DB	$00,$00,$00,$00,$00,$00,$00,$00
		.DB	$00,$00,$00,$00,$00,$00,$00,$00
		.DB	$FF

; ==========================================================================

SELEC_ARCH:	LD	A,$01
		LD	(NOMBRE_CORTO),A
		LD	HL,CATBUFFER
		LD	DE,CATBUFFER+1
		LD	BC,4095
		LD	(HL),$00
		LDIR
		LD	A,$FF
		LD	(POS_NOMBRE),A
		LD	B,25
		LD	C,$01
		LD	DE,CATBUFFER
		LD	A,(LODDRV)	;Buscamos la unidad por
		LD	(MASKZ80),A	;por defecto del sistema
		LD	HL,MASKZ80
		LD	IY,DOS_CATALOG	;lee el CATlogo "*.z80"
		CALL	P3DOS
		JP	NC,ERROR_7000H

		CALL	$0D6B
		LD	A,$02
		CALL	CHOPEN
		CALL	PR_LOGO
		LD	(IY+49),$00
		LD	HL,CATBUFFER+13
		DEC	B
		LD	A,B
		CP	25		;ajusta la cantidad de archs.
		JR	C,LPRINT_NAME	;a 24 si son ms de 24
		LD	B,24
LPRINT_NAME:	LD	A,(HL)
		AND	A
		JR	Z,NO_MAS_ARCHS
		PUSH	BC
		LD	B,$08
LLEFT_NAME:	PUSH	BC		;imprime nombre
		LD	A,(HL)
		RST	10H
		POP	BC
		INC	HL
		DJNZ	LLEFT_NAME
		INC	HL		;pero saltea la extensin
		INC	HL
		INC	HL
		LD	A,' '
		RST	10H
		LD	C,(HL)		;imprime tamao del arch.
		INC	HL
		LD	B,(HL)
		INC	HL
		PUSH	HL
		PUSH	BC
		LD	A,C
		CP	$63
		JR	NC,MENOR100
		PUSH	AF
		LD	A,' '
		RST	10H
		POP	AF
		CP	$0A
		JR	NC,MENOR100
		LD	A,' '
		RST	10H
MENOR100:	POP	BC
		CALL	PRNUMERO
		LD	A,'K'
		RST	10H
		LD	A,$0D
		RST	10H
		POP	HL
		POP	BC
		LD	A,(POS_NOMBRE)
		INC	A
		LD	(POS_NOMBRE),A
		DJNZ	LPRINT_NAME
		LD	A,13
		LD	(ANCHO_NAME+1),A

NO_MAS_ARCHS:	LD	(IY+49),$02	;fin del ctalogo
		LD	A,(POS_NOMBRE)	;retorna si no se imprimi
		CP	$FF		;ningn archivo
		JP	NZ,SELECT
		RST	08H
		.DB	34		;g File does not exist, 0:1
					;(NO HAY NINGUN *.Z80)

SELECT:		XOR	A
		LD	(LINEA),A
		CALL	DESTACA2
WKEY:		LD	(IY -50),$00
LKEY:		LD	A,(IY -50)
		AND	A
		JR	Z,LKEY
		CP	11		;cursor arriba
		JR	Z,MOVE_UP
		CP	10		;cursor abajo
		JR	Z,MOVE_DOWN
		CP	13		;ENTER
		JR	Z,ACEPTA
		CP	32		;SPACE (cancela)
		JP	Z,CANCEL
		JR	WKEY

MOVE_UP:	LD	A,(LINEA)	;MANEJA MOVIMIENTO ARRIBA
		AND	A
		JR	Z,MOVE_LAST
		DEC	A
		JR	OK_LINE
MOVE_LAST:	LD	A,(POS_NOMBRE)
OK_LINE:	LD	(LINEA),A
		CALL	DESTACA
		CALL	EXSOUND1	;SONIDO MOVIMIENTO CURSORES
		JR	WKEY

MOVE_DOWN:	LD	A,(POS_NOMBRE)	;MANEJA MOVIMIENTO ABAJO
		LD	C,A
		LD	A,(LINEA)
		CP	C
		JR	Z,MOVE_FIRST
		INC	A
		JR	OK_LINE
MOVE_FIRST:	XOR	A
		JR	OK_LINE

ACEPTA:		JP	SELECT_CAT	;SE PRESIONO ENTER

CANCEL:		CALL	EXSOUND2
		AND	$FF		;SE PRESIONO SPACE (CANCELA)
		RET

SELECT_VAR:	LD	HL,$0000	;SELECCIONA NOMBRE DENTRO DE N$
		LD	DE,$08		;SEGUN EL CONTENIDO DE (LINEA)
		LD	A,(LINEA)
		AND	A
		JR	Z,NO_SUMA2
		LD	B,A
LSUMA2:		ADD	HL,DE
		DJNZ	LSUMA2
NO_SUMA2:	EX	DE,HL
		LD	HL,(DIRNVAR)
		LD	BC,$0008
		ADD	HL,BC
		JR	RET_SELVAR

SELECT_CAT:	LD	HL,$0000	;SELECCIONA NOMBRE DE ARCHIVO
		LD	DE,13		;ALMACENADOS EN CATBUFFER+13
		LD	A,(LINEA)	;SEGUN EL CONTENIDO DE (LINEA)
		AND	A
		JR	Z,NO_SUMA
		LD	B,A
LSUMA:		ADD	HL,DE
		DJNZ	LSUMA
NO_SUMA:	EX	DE,HL
		LD	HL,CATBUFFER+13

RET_SELVAR:	ADD	HL,DE
		EX	DE,HL
SET_VARNOM_ARC:	LD	HL,NOMBRE
		LD	B,$08
LSET_LNAME:	LD	A,(DE)
		CP	' '
		JR	Z,MENOS_DE8
		LD	(HL),A
		INC	HL
		INC	DE
		DJNZ	LSET_LNAME
MENOS_DE8:	EX	DE,HL
		LD	HL,EXTENSION
		LD	BC,$05
		LDIR
		LD	A,(SELECT_DESC)
		AND	A
		JR	Z,WNOMBRE8
		LD	A,(ANCHO_NAME+1)
		LD	E,A
		LD	D,$00
		LD	HL,(START_DNAMES)
		LD	A,(LINEA)
		AND	A
		JR	Z,NO_SUMA3
		LD	B,A
LSUMA3:		ADD	HL,DE
		DJNZ	LSUMA3
NO_SUMA3:	LD	DE,NOMBRE8
		LD	A,(ANCHO_NAME+1)
		LD	B,A
		LD	C,32
		LD	DE,NOMBRE8
LNOMBRE32:	LD	A,(HL)
		LD	(DE),A
		DEC	C
		INC	HL
		INC	DE
		DJNZ	LNOMBRE32
		LD	A,C
		AND	A
		JR	Z,SNOMBRE8
		LD	B,C
		EX	DE,HL
B_LNOMBRE32:	LD	(HL),$20
		INC	HL
		DJNZ	B_LNOMBRE32
		EX	DE,HL
		JR	SNOMBRE8

WNOMBRE8:	LD	HL,NOMBRE
		LD	DE,NOMBRE8
		LD	B,$08
LNOMBRE8:	LD	A,(HL)
		CP	'.'
		JR	Z,SNOMBRE8
		LD	(DE),A
		INC	DE
		INC	HL
		DJNZ	LNOMBRE8
SNOMBRE8:	LD	A,$FF
		LD	(DE),A
		SCF
		CP	$FF
		RET

; ==========================================================================

DESTACA:	LD	A,$00		;DESTACA LA LINEA EN PANTALLA
		CALL	PRINT_ATTR	;QUE INDIQUE EL CONTENIDO (LINEA)
DESTACA2:	LD	A,(LINEA)	;primero restablece la linea que
		LD	(DESTACA+1),A	;indique (DESTACA+1)
PRINT_ATTR:	LD	L,A
		LD	H,$00
		ADD	HL,HL	;*2
		ADD	HL,HL	;*4
		ADD	HL,HL	;*8
		ADD	HL,HL	;*16
		ADD	HL,HL	;*32
		LD	DE,$5800	;comienzo attrs
		ADD	HL,DE
ANCHO_NAME:	LD	B,13
L0B73:		LD	A,(HL)
		AND	%00000111
		RLCA
		RLCA
		RLCA
		LD	C,A
		LD	A,(HL)
		AND	%00111000
		RRCA
		RRCA
		RRCA
		OR	C
		LD	C,A
		LD	A,(HL)
		XOR	$40
		AND	%11000000
		OR	C
		LD	(HL),A
		INC	HL
		DJNZ	L0B73
		RET

; ==========================================================================

NUEVO_MAPB:	LD	(DRIVEMAP),A	;NUESTRA PROPIA RUTINA DOS_MAP_B
		DI
		LD	HL,$5C00
		LD	DE,$C000
		LD	BC,203
		LDIR
		LD	A,$10
		LD	BC,PBANKM
		OUT	(C),A
		LD	A,$05
		CALL	PRINT_MENTBL
		CALL	ESPERATECLA
		LD	A,22
		RST	10H
		XOR	A
		RST	10H
		XOR	A
		RST	10H
		LD	B,64
LSPACES:	PUSH	BC
		LD	A,$20
		RST	10H
		POP	BC
		DJNZ	LSPACES
		DI
		LD	A,$07
		LD	(BANKM),A
		LD	BC,PBANKM
		OUT	(C),A
		LD	HL,$C000
		LD	DE,$5C00
		LD	BC,203
		LDIR
		EI
		RET

ESPERATECLA:	LD	BC,$00FE	;ESPERA LA PULSACION DE UNA TECLA
BUC_ESPERA1:	IN	A,(C)
		AND	$1F
		CP	$1F
		JR	NZ,BUC_ESPERA1	;ESPERA QUE NO ESTEN TECLAS PULSADAS
BUC_ESPERA2:	IN	A,(C)
		AND	$1F
		CP	$1F
		JR	Z,BUC_ESPERA2	;ESPERA QUE HAYA UNA TECLA PULSADA
		RET

; =============================================================================

PRNUMERO:	CALL	SAVE_REGS	;IMPRIME EL NUMERO EN 'BC' USANDO
		CALL	$2D2B		;STACK-BC y luego STR$
		CALL	$2DE3
		CALL	REST_REGS
		RET

; =============================================================================

SAVE_REGS:	EX	(SP),HL		;RUTINA ESTANDAR PARA GUARDAR REGS.
		PUSH	IX
		PUSH	BC
		PUSH	DE
		PUSH	AF
		PUSH	HL
		RET

REST_REGS:	POP	HL		;RUTINA ESTANDAR PARA RECUPERAR REGS.
		POP	AF
		POP	DE
		POP	BC
		POP	IX
		EX	(SP),HL
		RET
		
; =============================================================================

PR_LOGO:	LD	A,$1A		;LD A,(DE)
		LD	(LSCAN),A
		LD	A,$68
		LD	(LATTR+1),A
		LD	IX,LOGO		;EL LOGO ESTA COMPRIMIDO Y PRIMERO
		LD	HL,$B000	;LO DESCOMPRIME EN B000h
		LD	DE,$1F0
		CALL	UNCOMPRESS2

DSF_DIR:	LD	HL,$400F	;IMPRIME EL LOGO EN (DSF_DIR+1)
		PUSH	HL
		LD	DE,$B000

		LD	B,$05		;FILAS DE ALTO (5*8)
LFILA:		PUSH	HL
		PUSH	BC

		LD	B,$08
LFILA8:		PUSH	HL
		PUSH	BC
		LD	B,17		;ANCHO DEL GRAFICO (columnas)
LSCAN:		LD	A,(DE)
		LD	(HL),A
		CALL	NEXT_COL
		INC	DE
		DJNZ	LSCAN
		POP	BC
		POP	HL
		INC	H
		DJNZ	LFILA8
		POP	BC
		POP	HL
		CALL	NEXT_DSPL
		DJNZ	LFILA
		POP	HL
		LD	A,H		;CALCULA DIR. ATTRS.
		RRCA
		RRCA
		RRCA
		AND	$03
		OR	$58
		LD	H,A
		LD	B,$05
LATTR_F:	PUSH	BC
		PUSH	HL
		LD	B,17		;ANCHO DEL GRAFICO (columnas)
LATTR:		LD	(HL),$68	;PAPEL 5, INK0, BRIGHT 1
		CALL	NEXT_COL
		DJNZ	LATTR
		POP	HL
		LD	BC,$0020
		ADD	HL,BC
		LD	A,H
		CP	$5B
		JR	C,NO_ADJATTR
		LD	H,$58		;DIR. ATTR. SALIO DE LA PANTALLA
NO_ADJATTR:	POP	BC
		DJNZ	LATTR_F
		RET

NEXT_COL:	LD	A,L
		AND	%00011111
		CP	$1F
		JR	Z,F_COL
		INC	L
		RET
F_COL:		LD	A,L
		SUB	$1F
		LD	L,A
		RET

NEXT_DSPL:	LD	A,L
		AND	%11110000
		CP	$E0
		JR	Z,CHANGE_BLQ
		LD	A,L
		ADD	A,$20
		LD	L,A
		RET
CHANGE_BLQ:	LD	A,L
		AND	%00001111
		LD	L,A
		LD	A,H
		AND	%00011000
		JR	Z,SEG_TERCIO
		CP	%00001000
		JR	Z,TER_TERCIO
		LD	H,$40		;DIR. DF. SALIO DE LA PANTALLA
		RET
SEG_TERCIO:	LD	H,$48
		RET
TER_TERCIO:	LD	H,$50
		RET

; =============================================================================
; RUTINA DE LLAMADO A +3DOS, PERO SOLO SE USA PARA LECTURA DEL CATALOGO (SI
; FUERA NECESARIO), LA APERTURA DEL ARCHIVO, Y SETEO DE +3DOS.
;
; LUEGO CUANDO COMIENZE LA CARGA DEL SNAP SE DEJA PERMANENTEMENTE PAGINADA ROM2
; Y SUS RUTINAS SE USAN DIRECTAMENTE.
;
P3DOS:		DI
		LD	(CALLDOS+1),IY
		LD	IY,23610
		PUSH	AF
		PUSH	BC
		LD	A,(BANKM)
		OR	%00000111
		RES	4,A
		LD	BC,PBANKM
		LD	(BANKM),A
		OUT	(C),A
		POP	BC
		POP	AF
		EI

CALLDOS:	CALL	$0000

		DI
		PUSH	AF
		PUSH	BC
		LD	A,(BANKM)
		AND	%11111000
		SET	4,A
		LD	BC,PBANKM
		LD	(BANKM),A
		OUT	(C),A
		POP	BC
		POP	AF
		EI
		RET

; =============================================================================
; BUSCA LA VARIABLE 'A$' Y VERIFICA QUE TENGA UN CONTENIDO APROPIADO
; i.e. LET A$="d:nnnnnnnn.eee"
;
; Si no lo tiene se salta a ERRNOM_ARC y termina el programa, si el contenido
; es correcto, deja el nombre del drive (si lo tuviera) en la variable del
; sistema LODDRV, y el nombre SIN EXTENSION en VARNOM_ARC formateado en
; maysculas
BUSC_VAR_A:	LD	A,$41		;ID DE VARIABLE "A$"
		CALL	BUSC_VAR
		RET	NZ
		INC	HL
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		INC	HL
		LD	A,D
		AND	A
		JR	NZ,ERRNOM_ARC
		LD	A,E
		AND	A
		JR	Z,ERRNOM_ARC
		CP	11
		JR	NC,ERRNOM_ARC
		PUSH	HL
		POP	IX
		CP	3
		JR	C,NODRVNAME
		LD	A,(IX+1)
		CP	':'
		JR	NZ,NODRVNAME
		LD	A,(IX+0)
		AND	$DF
;		CP	'A'		;QUITADO PARA COMPATIBILIDAD CON +3e
;		JR	Z,OK_DRVNAME	;(antes solo se permitia las unidades
;		CP	'B'		;A y B)
;		JR	NZ,ERRNOM_ARC
OK_DRVNAME:	LD	(LODDRV),A
		INC	IX
		INC	IX
		DEC	E
		DEC	E
NODRVNAME:	LD	A,E
		CP	9
		JR	NC,ERRNOM_ARC
LARGOOK:	LD	B,A
		LD	DE,VARNOM_ARC
LVARNOM_ARC:	LD	A,(IX)
		CP	97
		JR	C,OKMAYS
		AND	$DF
OKMAYS:		LD	(DE),A
		INC	DE
		INC	IX
		DJNZ	LVARNOM_ARC
		LD	A,$01
		LD	(NOMBRE_CORTO),A
		LD	DE,VARNOM_ARC
		JP	SET_VARNOM_ARC

ERRNOM_ARC:	RST	08H
		.DB	14		; F Invalid file name, 0:1

; ==========================================================================
; BUSCA LA VARIABLE BASIC CUYO ID VIENE EN 'A'
; SALIDA: SI SE ENCUENTRA. 'Z=TRUE' HL=DIRECCION_VARIABLE
;	  SI NO SE ENCUENTRA. 'NZ=TRUE'
;
BUSC_VAR:	LD	HL,(VARS)
		LD	B,A
		LD	C,$80
LBUSC_VAR:	LD	A,C
		CP	(HL)
		JR	Z,NO_BUSC_VAR
		LD	A,B
		CP	(HL)
		JR	Z,OK_BUSC_VAR
		PUSH	BC
		CALL	FINDNEXT
		POP	BC
		EX	DE,HL
		JR	LBUSC_VAR
NO_BUSC_VAR:	CP	B
		LD	HL,$0000
OK_BUSC_VAR:	PUSH	HL
		POP	BC
		RET

; ==========================================================================
; BUSCA LA VARIABLE BASIC "DIM P(n,2)"
; Y PONE LOS VALORES DE LOS POKES EN EL PRE-BUFFER "GUARDAPOKES"
;
BUSC_POKES:	LD	A,%10010000	;DIM P(...)
		CALL	BUSC_VAR
		RET	NZ
		PUSH	HL
		POP	IX
		LD	A,(IX+3)	;retorna si la 2da. dimension<>2
		CP	2
		RET	NZ
		LD	A,(IX+5)
		AND	A
		RET	NZ
		LD	A,(IX+4)	;retorna si la 1ra. dimension>10
		CP	11
		RET	NC
		LD	B,A
		LD	(CANT_POKES),A	;guarda la cantidad de POKE's
		LD	A,(IX+6)
		CP	$02
		RET	NZ
		LD	A,(IX+7)
		AND	A
		RET	NZ
		LD	HL,GUARDAPOKES
LSET_POKES:	PUSH	BC
		LD	E,(IX+10)
		LD	D,(IX+11)
		LD	(HL),E
		INC	HL
		LD	(HL),D
		INC	HL
		LD	BC,$0005
		ADD	IX,BC
		LD	A,(IX+10)
		LD	(HL),A
		INC	HL
		ADD	IX,BC
		POP	BC
		DJNZ	LSET_POKES
		RET

;==========================================================================
;VARIOS SONIDOS DE AVISO (estilo nostalgia) - Ver HiLow
;
EXSOUND0:	CALL	SAVE_REGS	;Emite uno de los sonidos de
		LD	B,$64		;"movimiento" en la seleccin
		LD	HL,$1900	;de archivos o eleccin de opciones
RETSOUND:	CALL	SOUND_OUT	;en las ventanas-menu.
		CALL	REST_REGS
		RET

EXSOUND1:	CALL	SAVE_REGS	;Emite uno de los sonidos de
		LD	B,$64		;"movimiento" en la seleccin
		LD	HL,$1400	;de archivos o eleccin de opciones
		JR	RETSOUND	;en las ventanas-menu.

EXSOUND2:	CALL	SAVE_REGS	;Emite el sonido de cancelacin
		LD	B,$00		;cuando se presiona SPACE
		LD	HL,$3500
		JR	RETSOUND

EXSOUND3:	CALL	SAVE_REGS	;Emite el sonido de aceptacin
		LD	B,$96		;cuando se presiona SHIFT
		LD	HL,$2100
		JR	RETSOUND

EXSOUND4:	CALL	SAVE_REGS	;Emite el sonido de "sirena"
		LD	B,$00
		LD	HL,$1443
		JR	RETSOUND

SOUND_OUT:	LD	A,(23624)	;Esta rutina emite un sonido
		RRA			;En el registro B recibe la
		RRA			;duracin y en HL algn tipo
		RRA			;de "frecuencia".
SOUNDLOOP:	DEC	D
		JR	NZ,SRETARD1
		XOR	$10
		OUT	($FE),A
		LD	D,H
SRETARD1:	DEC	E
		JR	NZ,SRETARD2
		XOR	$10
		OUT	($FE),A
		LD	E,L
SRETARD2:	DEC	C
		JR	NZ,SOUNDLOOP
		XOR	$10
		OUT	($FE),A
		LD	C,B
		DJNZ	SOUNDLOOP
		RET

; ==========================================================================

CANT_POKES:	.DB	$00
GUARDAPOKES:	.DB	$00,$00,$00	;POKE 1
		.DB	$00,$00,$00	;POKE 2
		.DB	$00,$00,$00	;POKE 3
		.DB	$00,$00,$00	;POKE 4
		.DB	$00,$00,$00	;POKE 5
		.DB	$00,$00,$00	;POKE 6
		.DB	$00,$00,$00	;POKE 7
		.DB	$00,$00,$00	;POKE 8
		.DB	$00,$00,$00	;POKE 9
		.DB	$00,$00,$00	;POKE 10

; =========================================================================
; RUTINA DESCOMPRESORA METODO 2
; (solo se usa para descomp. el logo y los atributos que ocultan el prog.
; en pantalla)
; =========================================================================
; IX=Direccion del bloque comprimido
; HL=Direccion en donde poner el bloque descomprimido
; DE=Cantidad de bytes comprimidos

BLOCKID:	.EQU	$ED

UNCOMPRESS2:	LD	A,D
		OR	E
		RET	Z
		LD	A,(IX+0)
		CP	BLOCKID
		JR	NZ,B_NOREP
		CP	(IX+1)
		JR	NZ,B_UNICO
		LD	B,(IX+2)
		LD	A,(IX+3)
L_REP2:		LD	(HL),A
		INC	HL
		DJNZ	L_REP2
		INC	IX
		INC	IX
		DEC	DE
		DEC	DE
RET_UNICO:	INC	IX
		DEC	DE
RET_NOREP:	INC	IX
		DEC	DE
		JR	UNCOMPRESS2

B_UNICO:	LD	(HL),BLOCKID
		INC	HL
		LD	A,(IX+1)
		LD	(HL),A
		INC	HL
		JR	RET_UNICO

B_NOREP:	LD	(HL),A
		INC	HL
		JR	RET_NOREP

; =========================================================================
; LOGO COMPRIMIDO
LOGO:		.DB	$ED,$ED,$11,$FF,$80,$ED,$ED,$0F
		.DB	$00,$01,$BF,$ED,$ED,$0F,$FF,$FD
		.DB	$A0,$ED,$ED,$0F,$00,$05,$AF,$ED
		.DB	$ED,$0F,$FF,$F5,$A8,$ED,$ED,$0F
		.DB	$00,$15,$A8,$ED,$ED,$0F,$00,$15
		.DB	$A8,$ED,$ED,$0F,$00,$15,$A8,$3F
		.DB	$FF,$FF,$01,$FF,$80,$3F,$F8,$00
		.DB	$03,$FF,$FF,$FF,$FE,$00,$15,$A8
		.DB	$00,$00,$01,$80,$00,$40,$00,$02
		.DB	$ED,$ED,$06,$00,$0C,$15,$A8,$3F
		.DB	$FF,$FF,$8F,$FF,$E0,$FF,$FF,$00
		.DB	$0F,$FF,$FF,$FF,$F9,$12,$15,$A8
		.DB	$00,$00,$03,$80,$00,$20,$03,$80
		.DB	$80,$00,$00,$00,$00,$01,$04,$15
		.DB	$A8,$00,$01,$FF,$1F,$FF,$F1,$FF
		.DB	$FF,$80,$3F,$FF,$FF,$FF,$E7,$C2
		.DB	$15,$A8,$00,$00,$0E,$00,$FC,$18
		.DB	$07,$00,$C0,$00,$00,$00,$00,$01
		.DB	$12,$15,$A8,$00,$07,$FC,$1F,$C7
		.DB	$F9,$FE,$3F,$C0,$FF,$FF,$FF,$FF
		.DB	$81,$0C,$15,$A8,$00,$00,'8',$01
		.DB	$80,$18,$06,$00,$C0,$ED,$ED,$06
		.DB	$00,$15,$A8,$00,$1F,$F0,$1F,$C3
		.DB	$F9,$FE,$3F,$C0,$ED,$ED,$06,$00
		.DB	$15,$A8,$00,$00,$E0,$00,$C0,'0'
		.DB	$06,$00,$C0,$ED,$ED,$06,$00,$15
		.DB	$A8,$00,$7F,$C0,$0F,$FF,$F1,$FE
		.DB	$3F,$C0,$ED,$ED,$06,$00,$15,$A8
		.DB	$00,$03,$80,$00,$00,'0',$06,$00
		.DB	$C0,$ED,$ED,$06,$00,$15,$A8,$01
		.DB	$FF,$00,$0F,$FF,$F1,$FE,$3F,$C0
		.DB	$C0,$00,$00,$06,$00,$00,$15,$A8
		.DB	$00,$0E,$00,$00,$00,$18,$06,$00
		.DB	$C0,$C0,$00,$00,$06,$00,$00,$15
		.DB	$A8,$07,$FC,$00,$1F,$FF,$F9,$FE
		.DB	$3F,$C0,$C0,$00,$00,$06,$00,$00
		.DB	$15,$A8,$00,'8',$00,$00,$FC,$18
		.DB	$06,$00,$C0,$C3,$C1,$F0,'v',$1C
		.DB	'6',$15,$A8,$1F,$F0,$00,$1F,$C7
		.DB	$F9,$FE,$3F,$C0,$C7,$E3,$F8,$FE
		.DB	'>','>',$15,$A8,$00,$E0,$00,$01
		.DB	$80,$18,$06,$00,$C0,$CE,'s',$19
		.DB	$CE,'c','8',$15,$A8,$7F,$C0,$00
		.DB	$1F,$81,$F9,$FE,$3F,$C0,$CC,'0'
		.DB	'y',$86,$7F,'0',$15,$A8,$01,$80
		.DB	$00,$00,$C0,'8',$00,$01,$C0,$CC
		.DB	'1',$F9,$86,$7F,'0',$15,$A8,$7F
		.DB	$FF,$FF,$0F,$FF,$F0,$FF,$FF,$80
		.DB	$CC,'3',$99,$86,'`','0',$15,$A8
		.DB	$00,$00,$01,$80,$00,'p',$00,$07
		.DB	$80,$CE,'s',$19,$CE,'s','0',$15
		.DB	$A8,$7F,$FF,$FF,$83,$FF,$E0,$3F
		.DB	$FF,$00,$C7,$E3,$F8,$FE,'>','0'
		.DB	$15,$A8,$3F,$FF,$FF,$81,$FF,$C0
		.DB	$1F,$FE,$00,$C3,$C1,$EC,'v',$1C
		.DB	'0',$15,$A8,$1F,$FF,$FF,$80,$FF
		.DB	$00,$07,$F8,$ED,$ED,$07,$00,$15
		.DB	$A8,$ED,$ED,$0F,$00,$15,$A8,$ED
		.DB	$ED,$0F,$00,$15,$AF,$ED,$ED,$0F
		.DB	$FF,$F5,$A0,$ED,$ED,$0F,$00,$05
		.DB	$BF,$ED,$ED,$0F,$FF,$FD,$80,$ED
		.DB	$ED,$0F,$00,$01,$ED,$ED,$11,$FF

MASKZ80:	.DB	"B:*"
EXTENSION:	.DB	".Z80",$FF
LINEA:		.DB	$00
POS_NOMBRE:	.DB	$00
FILENAME:	.DB	"A:"
NOMBRE:		.DB	"12345678.123",$FF
VARNOM_ARC:	.DB	"        "
DIRNVAR:	.DW	$0000
START_DNAMES:	.DW	$0000
SELECT_DESC:	.DB	$00
MF3:		.DB	$00

CATBUFFER:	.EQU	$9000				;BUFFER PARA EL
BORDCR:		.EQU	23624				;CATALOGO DE DISCO
LODDRV:		.EQU	$5B79
FLAGS3:		.EQU	$5B66
VARS:		.EQU	23627
FINDNEXT:	.EQU	$19B8
CHOPEN:		.EQU	$1601

ATTRS:   	.DB	$00,$ED,$ED,$0A,$12,$00,$00,$ED	;attrs de la pantalla
		.DB	$ED,$07,$12,$00,$00,$00,$00,$ED	;que forman la palabra
		.DB	$ED,$05,$12,$00,$00,$00,$00,$ED	;Z80
		.DB	$ED,$0A,$12,$00,$ED,$ED,$09,$12	;estos atributos son
		.DB	$00,$ED,$ED,$09,$12,$ED,$ED,$09	;usados para ocultar el
		.DB	$00,$12,$12,$12,$00,$12,$12,$ED	;programa cargador que
		.DB	$ED,$05,$00,$12,$12,$00,$12,$12	;va en el 1er. tercio
		.DB	$ED,$ED,$05,$00,$12,$12,$ED,$ED	;de pantalla
		.DB	$06,$00,$12,$12,$12,$12,$00,$00
		.DB	$00,$00,$ED,$ED,$07,$12,$00,$00
		.DB	$12,$12,$ED,$ED,$05,$00,$12,$12
		.DB	$00,$00,$00,$00,$12,$12,$12,$12
		.DB	$ED,$ED,$06,$00,$ED,$ED,$07,$12
		.DB	$00,$00,$12,$12,$ED,$ED,$05,$00
		.DB	$12,$12,$00,$00,$12,$12,$12,$ED
		.DB	$ED,$08,$00,$12,$12,$ED,$ED,$05
		.DB	$00,$12,$12,$00,$12,$12,$ED,$ED
		.DB	$05,$00,$12,$12,$00,$00,$ED,$ED
		.DB	$0A,$12,$00,$ED,$ED,$09,$12,$00
		.DB	$ED,$ED,$09,$12,$00,$00,$ED,$ED
		.DB	$0A,$12,$00,$00,$ED,$ED,$07,$12
		.DB	$00,$00,$00,$00,$ED,$ED,$05,$12
		.DB	$00,$00,$00

LOADER:		.EQU	$

; ==========================================================================
		.ORG	16384
; ==========================================================================

BOOT48K:	LDIR
		LD	BC,PBANKM			;$DB $BF NOP
		OUT	(C),A				;NOP NOP
BOOT128K:
RDE:		LD	DE,$0000
RBC:		LD	BC,$0000
RAF:		LD	HL,$0000
		PUSH	HL
RHL:		LD	HL,$0000
RREF:		LD	A,$00
		LD	R,A
		POP	AF				;REFRESH+1
INT:		.DB	$00	;DI=F3 , EI=FB		;REFRESH+1
RPC:		JP	$0000				;REFRESH+1

; ==========================================================================
; POKEA EL JUEGO DENTRO DE LA CONFIGURACION DE RAM *ACTIVA* EN EL MOMENTO DE 
; *SALVAR* EL Z80
; (LOS POKES SON SEGUN LO QUE INDIQUE LA ZONA DE "POKES" ENTRE LAS 
; DIRECCIONES 5B00h a FFFFh, bueno... aunque en teoria se puede pokear 
; entre 0 y FFFF)
;
POKEAR:		LD	A,(POKES)	;TO DO: HACER UN SISTEMA DE POKEADO
		AND	A		;	MULTIPAGINAS PARA 128K
		RET	Z
		LD	HL,POKES+1
		LD	B,A
LPOKEAR:	LD	E,(HL)
		INC	HL
		LD	D,(HL)
		INC	HL
		LD	A,D
		OR	E
		JR	Z,NOPOKE
		LD	A,(HL)
		LD	(DE),A
NOPOKE:		INC	HL
		DJNZ	LPOKEAR
		RET

; ==========================================================================
; LEE LOS REGISTROS Y MODIFICA LAS RUTINAS "SET_REG" Y "BOOT128K" PARA QUE
; ASIGNEN SUS VALORES LUEGO DE CARGAR Y DESCOMPRIMIR EL SNAP, TAMBIEN LEE
; LOS VALORES DE LOS REGISTROS DEL AY-3-8912
;
; (los comentarios en ingls son tomados del TECHINFO.TXT de G.A.Lunter)
;
READ_REG:	LD	HL,$0000
		CALL	SETPOS
		JP	NC,P3DOSERROR
		LD	HL,$0000
		LD	(RPC+1),HL

		CALL	READ16		;AF
		LD	A,H
		LD	H,L
		LD	L,A
		LD	(RAF+1),HL
		CALL	READ16		;BC
		LD	(RBC+1),HL
		CALL	READ16		;HL
		LD	(RHL+1),HL
		CALL	READ16		;PC (V1.45)
		LD	(RPC+1),HL
		CALL	READ16		;SP
		LD	(RSP),HL
		CALL	READ08	;I
		LD	(RINT+1),A
		CALL	READ08		;R
		AND	%01111111
		LD	H,A
		PUSH	HL
		CALL	READ08		;Bit 0 : Bit 7 of the R-register
					;Bit 1-3: Border colour
		POP	HL
		LD	L,A
		BIT	0,A
		JR	Z,RES0_REF
		SET	7,H
		JR	SET_REF
RES0_REF:	RES	7,H
SET_REF:	LD	A,H
		DEC	A		;COMPENSA EL INCREMENTO DESPUES DE
		DEC	A		;EJECUTAR BOOT48K o BOOT128K
		DEC	A
		LD	(RREF+1),A
		LD	A,L
		RRCA
		AND	$07
		LD	(BORDE+1),A
		CALL	READ16		;DE
		LD	(RDE+1),HL
		CALL	READ16		;BC'
		LD	(ALTBC+1),HL
		CALL	READ16		;DE'
		LD	(ALTDE+1),HL
		CALL	READ16		;HL'
		LD	(ALTHL+1),HL
		CALL	READ16		;AF'
		LD	A,H
		LD	H,L
		LD	L,A
		LD	(ALTAF+1),HL
		CALL	READ16		;IY
		LD	(RIY+2),HL
		CALL	READ16		;IX
		LD	(RIX+2),HL
		CALL	READ08		;EI/DI
		AND	A
		LD	A,$F3
		JR	Z,SET_INT
		LD	A,$FB
SET_INT:	LD	(INT),A
		CALL	READ08		;IFF2 (not particularly important...)
		CALL	READ08		;Bit 0-1: Interrupt mode (0, 1 or 2)
		AND	%00000011
		AND	A
		JR	Z,SET_IM0
		CP	$01
		JR	Z,SET_IM1
		LD	A,$5E
		JR	PUT_INT
SET_IM1:	LD	A,$56
		JR	PUT_INT
SET_IM0:	LD	A,$46
PUT_INT:	LD	(IM_MODE),A
		LD	HL,(RPC+1)
		LD	A,H
		OR	L
		RET	NZ
		CALL	READ16		;Length of additional header block
		CALL	READ16		;PC
		LD	(RPC+1),HL

		LD	HL,35
		CALL	SETPOS
		JP	NC,P3DOSERROR
		CALL	READ08		;in 128 mode, contains last OUT to 7ffd
		LD	(LAST_7FFD),A
		CALL	READ16		;dummy
		CALL	READ08		;Last OUT to fffd (soundchip reg nr)
		LD	(LAST_FFFD),A
		LD	B,16
		LD	HL,AY_REGS
LSTORE_AY:	PUSH	BC
		PUSH	HL
		CALL	READ08		;*16 Contents of the sound chip regs
		POP	HL
		POP	BC
		LD	(HL),A
		INC	HL
		DJNZ	LSTORE_AY
		
		LD	A,(TIPOSNAP)
		CP	7
		RET	NZ		;ENTONCES ES UN Z80 +3 o +2A
		LD	HL,$0056	;SE PROCEDE A RECUPERAR EL
		CALL	SETPOS		;ULTIMO DATO ENVIADO AL PUERTO
		JP	NC,P3DOSERROR	;1FFDh
		CALL	READ08
		LD	(LAST_1FFD),A
		RET

LAST_FFFD:	.DB	$00

; ==========================================================================

SET_REG:	DI			;CARGA LOS REGISTROS PRELIMINARES QUE
		EXX			;NO SE USAN BOOT48K o BOOT128K.
ALTHL:		LD	HL,$0000
ALTDE:		LD	DE,$0000	;ESTA RUTINA ES MODIFICADA POR READ_REG
ALTBC:		LD	BC,$0000
		EXX
RIX:		LD	IX,$0000	;+2
RIY:		LD	IY,$0000	;+2
ALTAF:		LD	HL,$0000
		EX	AF,AF'
		PUSH	HL
		POP	AF
		EX	AF,AF'
		.DB	$ED		;(EDxx) = IM x
IM_MODE:	.DB	$00		;MODO: 0=46, 1=56, 2=5E
RINT:		LD	A,$00
		LD	I,A
BORDE:		LD	A,$00
		OUT	($FE),A
		RET

; ==========================================================================
;
GET_TAMPAG:	CALL	READ16		;RETORNA HL=CANTIDAD DE BYTES
		PUSH	HL		;COMPRIMIDOS Y A=NRO. PAGINA RAM
		CALL	READ08		;EN DONDE SE DEBERIA DESCOMPRIMIR
		POP	HL
		LD	(PAG_FILE),A
		SUB	$03
		AND	$07
		RET

; ==========================================================================
; POSICIONA EL PUNTERO LUEGO DE LA CABECERA
;
GO_FIRSTPAG:	LD	HL,$001E
		CALL	SETPOS
		JP	NC,P3DOSERROR
		CALL	READ08
		PUSH	AF
		CALL	READ08
		LD	H,A
		POP	AF
		LD	L,A
		LD	BC,$0020
		ADD	HL,BC
		CALL	SETPOS
		JP	NC,P3DOSERROR
		RET

; ==========================================================================
; POSICIONA EL PUNTERO DEL ARCHIVO EN LA PAGINA INDICADA POR 'A'
; EL PUNTERO QUEDA POSICIONADO EN EL PRIMER BYTE "COMPRIMIDO"
; RETORNA EN "HL" EL TAMAO DE LA PAGINA COMPRIMIDA
;
GOTO_PAG:	PUSH	AF
		CALL	GO_FIRSTPAG
		POP	AF
		LD	(COMPARA_PAG+1),A
		LD	B,A
LBUSC_PAG5:	PUSH	BC
		CALL	GET_TAMPAG
		PUSH	HL
		CALL	GETPOS
		POP	BC
		ADD	HL,BC
		JR	NC,NO_OVERF
		INC	E
NO_OVERF:	CALL	SETPOS_EHL
		JP	NC,P3DOSERROR
		POP	BC
		DJNZ	LBUSC_PAG5
		CALL	GET_TAMPAG
COMPARA_PAG:	CP	$00
		JP	NZ,ERRSNAP
		RET

; ==========================================================================
; DESCOMPRIME UNA PAGINA QUE YA EST A PARTIR DE C000h
;
; HL = CANTIDAD DE BYTES A LEER (COMPRIMIDOS)
; A  = PAGINA DE RAM EN DONDE SE DESCOMPRIME EL BLOQUE
;
UNP_PAG:	LD	(COUNT),HL
		PUSH	AF
		LD	B,$06
		LD	C,A
		LD	DE,$C000
		LD	(CPOS),DE
		EX	DE,HL
		CALL	READ
		JP	NC,P3DOSERROR
		POP	AF
		LD	BC,PBANKM
SCREEN2_A:	OR	%00000000
		OUT	(C),A

UNP_PAG2:	LD	DE,$FFFF	;ENTRADA ALTERNATIVA PARA DESCOMPRIMIR
		LD	BC,(COUNT)	;PAGINA 7
		LD	HL,$C000
		ADD	HL,BC
		DEC	HL
		LDDR
		INC	DE
		LD	(ORIGEN),DE

		LD	IX,DESCOMP_BUFF	;DIRECCION PREBUFFER DE DESCOMPRESION
		LD	HL,$0000
		LD	(CTRL_BUFFER),HL

BUCL_UNP:	CALL	GETBYTE
		CP	$ED
		JR	NZ,NOREP	;BYTE NO REPETIDO
		CALL	GETBYTE
		CP	$ED
		JR	NZ,UNICO	;UNICO EDh segido por otro byte
		CALL	GETBYTE		;CAMTIDAD DE VECES QUE ESTA REPETIDO

		LD	B,A
		CALL	GETBYTE		;VALOR DEL BYTE REPETIDO
LREPEAT:	CALL	PUTBYTE		;DESCOMPRIME LOS BYTES REPETIDOS
		INC	IX
		DJNZ	LREPEAT

TEST_END:	LD	HL,(COUNT)
		LD	A,H
		OR	L
		JR	NZ,BUCL_UNP

		XOR	A		;TERMINA Y VUELVE A DEJAR PAGINA 7
		OUT	($FE),A
		LD	HL,$FEFF
		LD	DE,$FFFF
		LD	BC,16383
		LDDR
		LD	HL,DESCOMP_BUFF
		LD	DE,$C000
		LD	BC,$100
		LDIR
		LD	BC,PBANKM
SCREEN2_B:	LD	A,$07
		OUT	(C),A
		RET

UNICO:		PUSH	AF		;UNICO EDh segido por otro byte
		LD	A,$ED
		CALL	PUTBYTE
		POP	AF
		INC	IX
NOREP:		CALL	PUTBYTE		;BYTE UNICO
		INC	IX
		JR	TEST_END

GETBYTE:	LD	HL,(ORIGEN)
		LD	A,(HL)
		AND	$07
		OUT	($FE),A		;SE HACE UN "JUEGITO" CON LOS BYTES
		LD	A,(HL)		;DESCOMPRIMIDOS PARA QUE EL USUARIO
		INC	HL		;"VEA" QUE TODO VA MARCHANDO BIEN
		LD	(ORIGEN),HL
		LD	HL,(COUNT)
		DEC	HL
		LD	(COUNT),HL
		RET

PUTBYTE:	PUSH	AF		;CONTROL DEL PREBUFFER PARA EVITAR
		LD	HL,(CTRL_BUFFER);SOLAPAMIENTOS EN LA DESCOMPRESION
		LD	A,H
		CP	$01		;SE METEN 256 EN UN BUFFER INTERNO
		JR	Z,PUT_RAM	;Y LUEGO SE CONTINUA DESDE...
		POP	AF
		PUSH	AF
		LD	(IX+0),A
		INC	HL
		LD	(CTRL_BUFFER),HL
		LD	A,H
		CP	$01
		JR	NZ,NO_PREBUF
		LD	IX,$BFFF	;... C000h HASTA FEFFh, luego al
NO_PREBUF:	POP	AF		;final de las descompresion se
		RET			;junta todo.

PUT_RAM:	POP	AF
		PUSH	AF		;SE EVITA AQUI UN POSIBLE DESBORDE
		.DB	$DD		;SI Ix>FEFF (sntoma de que el SNAP
		LD	A,H		;podra estar corrupto)
		CP	$FF
		JP	Z,ERRSNAP
		POP	AF
		LD	(IX+0),A
		RET

; ==========================================================================
; RUTINAS DE APOYO PARA LA LECTURA DE LOS SNAPs DESDE DISCO
;
READ16:		PUSH	IX		;RETORNA EN HL LA PALABRA LEIDA DEL
		CALL	READ08		;ARCHIVO ABIERTO EN 06h
		PUSH	AF
		CALL	READ08
		LD	H,A
		POP	AF
		LD	L,A
		POP	IX
		RET

READ08:		PUSH	IX		;RETORNA EL 'A' EL BYTE LEIDO DEL
		LD	BC,$0607	;ARCHIVO ABIERTO EN 06h
		LD	DE,$0001
		LD	HL,BYTER+1
		CALL	READ
		JR	NC,P3DOSERROR
BYTER:		LD	A,$00
		POP	IX
		RET

; ==========================================================================

SETPOS:		LD	E,$00		;POSICIONA EN 'HL' EL ARCH. #06
SETPOS_EHL:	LD	B,$06		;POSICIONA EN 'EHL' EL ARCH. #06
		LD	D,$00
		JP	$136

; ==========================================================================

GETPOS:		LD	B,$06		;RETORNA EN 'EHL' LA POSICION DEL
		JP	$133		;ARCHIVO #06

; ==========================================================================

ERRSNAP:	LD	A,$FF

P3DOSERROR:	DI			;'CUELGA' EL PROGRAMA PARA INDICAR
		PUSH	AF		;ERROR EN +3DOS
		LD	A,$04
		LD	BC,PBANKM
		OUT	(C),A
		CALL	DD_L_OFFMOTOR
		LD	A,$10
		LD	BC,PBANKM
		OUT	(C),A
		LD	A,$01
		CALL	CHOPEN
		POP	AF
		PUSH	AF
		CP	$FF
		JR	NZ,ERRP3DOS
		LD	HL,MESSERRSNAP
		JR	LMESSERR

ERRP3DOS:	LD	HL,MESSERR
LMESSERR:	CALL	PR_MEN
		POP	AF
		LD	L,A
		LD	H,$00
		CP	$FF
		JR	NZ,GENUINO_P3DOS
		LD	A,(PAG_FILE)
		LD	L,A
		LD	H,$00
GENUINO_P3DOS:	CALL	NUMBER2

BLOQUEO:	LD	BC,309
		EI
		HALT
		DI
		LD	D,$00
		LD	HL,$0128
ERRW:		DEC	BC
		LD	A,B
		OR	C
		JR	NZ,ERRW
ERROR1A:	LD	A,D
		INC	A
		AND	$07
		OUT	($FE),A
		LD	D,A
		PUSH	HL
		POP	BC
ERROR2A:	DEC	BC
		LD	A,B
		OR	C
		JR	NZ,ERROR2A
		JR	ERROR1A

NUMBER2:	LD	DE,10		;IMPRIME UN NRO. <= 99
		CALL	DIVID1
NUMBER1:	LD	C,L
		JR	DIVID2
DIVID1:		AND	A
		LD	C,0
LCALC2:		SBC	HL,DE
		JR	C,DIVID2
		INC	C
		JR	LCALC2
DIVID2:		ADD	HL,DE
		LD	A,'0'
		ADD	A,C
		RST	10H
		RET

PR_MEN:		LD	A,(HL)
		CP	$FF
		RET	Z
		RST	10H
		INC	HL
		JR	PR_MEN

PRHEX:		LD	A,H
		CALL	PRHEX_LEFT
		LD	A,H
		CALL	PRHEX_RIGHT
		LD	A,L
		CALL	PRHEX_LEFT
		LD	A,L
		CALL	PRHEX_RIGHT
		RET

PRHEX_LEFT:	AND	%11110000
		SRL	A
		SRL	A
		SRL	A
		SRL	A
CONT_DIGITX:	CP	$0A
		JR	NC,SUMA_A
		ADD	A,'0'
		RST	10H
		RET
SUMA_A:		ADD	A,$37
		RST	10H
		RET

PRHEX_RIGHT:	AND	%00001111
		JR	CONT_DIGITX

MESSERR:	.DB	22,1,0,"+3DOS ERR:"
		.DB	$FF
MESSERRSNAP:	.DB	22,1,0,"ERR Z80 format, PAG:"
		.DB	$FF
MSGAT:		.DB	22,0,0,$FF

; ==========================================================================
; PARA QUE NO MOLESTE LA RUTINA DE LECTURA DEL TECLADO O EL MOTOR DEL DRIVE
; (corrompera parte del prog. cargado al alterar las vars. del sistema)
INTERRUP:	RETI

SET_MYINT:	DI
		LD	HL,INTERRUP
		LD	($47FF),HL
		LD	A,$47
		LD	I,A
		IM	2
		RET

; ==========================================================================

OPEN:		.EQU	$0106	; RUTINAS +3DOS Y VARS. QUE SE USAN
READ:		.EQU	$0112
CLOSE:		.EQU	$0109
DOS_SET_1234:	.EQU	$013F
DOS_MAP_B:	.EQU	$0154
DOS_SET_ALERT:	.EQU	$014E
DOS_CATALOG:	.EQU	$011E
DD_L_OFFMOTOR:	.EQU	$019C
BANKM:		.EQU	$5B5C
PBANKM:		.EQU	$7FFD
PBANK678:	.EQU	$1FFD
TMOTOR_OFF:	.EQU	$E600

AY_REGS:	.DB	$00,$00,$00,$00	;aqui se guardan momentneamente los
		.DB	$00,$00,$00,$00	;registros del AY-3-8912 para ser
		.DB	$00,$00,$00,$00	;recuperados antes de lanzar el Z80
		.DB	$00,$00,$00,$00

TIPOSNAP:	.DB	$00
CPOS:		.DW	$0000
COUNT:		.DW	$0000
ORIGEN:		.DW	$0000
P7_TAM:		.DW	$0000
LAST_7FFD:	.DB	$00
LAST_1FFD:	.DB	$04
PAG_FILE:	.DB	$00
CTRL_BUFFER:	.DW	$0000
RSP:		.DW	$0000
MULTIFACE3:	.DB	$00

POKES:		.DB	$00		;CANTIDAD DE POKES
		.DB	$00,$00,$00	;POKE 1
		.DB	$00,$00,$00	;POKE 2
		.DB	$00,$00,$00	;POKE 3
		.DB	$00,$00,$00	;POKE 4
		.DB	$00,$00,$00	;POKE 5
		.DB	$00,$00,$00	;POKE 6
		.DB	$00,$00,$00	;POKE 7
		.DB	$00,$00,$00	;POKE 8
		.DB	$00,$00,$00	;POKE 9
		.DB	$00,$00,$00	;POKE 10

		.DW	$0,$0,$0,$0,$0	;TAMAO DEL STACK
		.DW	$0,$0,$0,$0,$0	;AUN NO PUDE DETERMINAR EL TAMAO
		.DW	$0,$0,$0,$0,$0	;MINIMO DEL STACK PERO 100 BYTES
		.DW	$0,$0,$0,$0,$0	;PARECE SER UN BUEN VALOR (+3DOS
		.DW	$0,$0,$0,$0,$0	;USA MUCHO ESPACIO PARA EL STACK)
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0	;NOTA:
		.DW	$0,$0,$0,$0,$0	;prefiero reservar el espacio usando
		.DW	$0,$0,$0,$0,$0	;dw's as me quedo mas tranquilo...
		.DW	$0,$0,$0,$0,$0	;es una mana que tengo :)
STACK		.EQU	$

BUFF_IMP:	.DW	$0,$0,$0,$0,$0	;RESERVO 256 PARA GUARDAR (5B00-5BFF)
		.DW	$0,$0,$0,$0,$0	;ESTO ES UN DESPERDICIO PERO
		.DW	$0,$0,$0,$0,$0	;LAMENTABLEMENTE ES NECESARIO PORQUE
		.DW	$0,$0,$0,$0,$0	;+3DOS PUEDE LLEGAR A CORROMPER ESTA
		.DW	$0,$0,$0,$0,$0	;ZONA UNA VEZ CARGADA LA PAG 5
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0

DESCOMP_BUFF:	.DW	$0,$0,$0,$0,$0	;RESERVO 256 PARA EL BUFFER
		.DW	$0,$0,$0,$0,$0	;DE DESCOMPRESION
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0,$0,$0
		.DW	$0,$0,$0

BOOTEADOR:	.EQU	$

; ==========================================================================
; COMIENZA LA CARGA DE UN SNAP 128K
; ==========================================================================

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		.ORG	BOOTEADOR ;!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		.TEXT	"SNAP128K"

SNAP128K:	CALL	READ_REG	;LEE REGISTROS DEL SNAP DESDE EL ARCH.
		LD	A,5
		CALL	GOTO_PAG	;BUSCA LA PAGINA 8 (DEL ARCHIVO RAM5)
		LD	A,6
		CALL	UNP_PAG		;Y LA DESCOMPRIME EN LA PAGINA 6
		LD	A,$06
		LD	BC,PBANKM
		OUT	(C),A

		LD	A,(MULTIFACE3)	;SI HAY MF3 HACE UNA COPIA DEL PRIMER
		AND	A		;TERCIO DEL SCREEN$ DEL Z80 EN
		JR	Z,NO_COPYSCR	;"SU" MEMORIA DE ESTE MODO PODEMOS
		IN_MF3			;AL FINAL RECUPERAR "TODA" LA MEMORIA
		LD	HL,$C000	;128K
		LD	DE,$2000
		LD	BC,6912
		LDIR
		OUT_MF3
		LD	A,$07
		LD	BC,PBANKM
		OUT	(C),A
		JR	M_SCREEN0

NO_COPYSCR:	LD	HL,$C000
		LD	DE,$8000
		LD	BC,$1B00
		LDIR
		LD	A,$0F		;PONE LA PANTALLA EN SCREEN2
		LD	BC,PBANKM	;el motivo de esto es poder ver
		OUT	(C),A		;la pantalla completa mientras se
		LD	HL,$8000	;carga el juego, ya que podra haber
		LD	DE,$C000	;en ella algn men o un mensaje que
		LD	BC,$1B00	;necesitemos saber para usar el juego
		LDIR			;(SI ES QUE NO HAY MF3)
		LD	A,%00001111
		LD	(BANKM),A
		LD	(SCREEN2_B+1),A
		LD	(SCREEN2_D+1),A
		LD	A,%00001000
		LD	(SCREEN2_A+1),A
		LD	A,%00001110
		LD	(SCREEN2_C+1),A

M_SCREEN0:	CALL	GO_FIRSTPAG
		XOR	A		;CARGA Y DESCOMPRIME PAGINAS:
LPAG_01234:	PUSH	AF		;0,1,2,3, y 4
		CALL	GET_TAMPAG
		LD	C,A
		POP	AF
		CP	C
		JP	NZ,ERRSNAP
		PUSH	AF
		CALL	UNP_PAG
		POP	AF
		INC	A
		CP	5
		JR	NZ,LPAG_01234

		CALL	GET_TAMPAG	;DESCOMPRIME PAGINA 8 (DEL ARCHIVO QUE
		CP	5		;CORRESPONDE A LA PAGINA 5 DE LA RAM)
		JP	NZ,ERRSNAP
		LD	A,6		;EN PAGINA 6 DE RAM (aunque ya estaba
		CALL	UNP_PAG		;descomprimida, pero por las dudas)

SCREEN2_C:	LD	A,$06
		LD	BC,PBANKM
		OUT	(C),A

		LD	HL,$C000+2049	;PARTE DE LA PANTALLA QUE SE
		LD	DE,$4000+2049	;PUEDE USAR SIN PELIGRO
		LD	BC,4095+768	;TERCIOS 2 y 3 + ATRIBUTOS
		LDIR			;MENOS UN BYTE PARA NO ALTERAR 4800h
					;(vector int)

		LD	HL,$DB00       	;GUARDA "BUFFER IMPRESORA"
		LD	DE,BUFF_IMP	;PORQUE TODAVIA HAY QUE USAR +3DOS
		LD	BC,256
		LDIR

		LD	HL,$C000+$1C00	;COPIAR DESDE DC00h en 5C00h
		LD	DE,$4000+$1C00	;DE PAGINA 5
		LD	BC,$4000-$1C00
		LDIR

SCREEN2_D:	LD	A,$07
		LD	BC,PBANKM
		OUT	(C),A

		CALL	GET_TAMPAG	;DESCOMPRIME PAGINA 9 (DEL ARCHIVO)
		CP	6		;EN PAGINA 6 DE RAM (CORRECTO)
		JP	NZ,ERRSNAP
		CALL	UNP_PAG

		CALL	GET_TAMPAG
		CP	7
		JP	NZ,ERRSNAP
		LD	(P7_TAM),HL

		LD	A,$07
		LD	(SCREEN2_B+1),A
		LD	(BANKM),A
		LD	BC,PBANKM
		OUT	(C),A
		LD	A,%00000000
		LD	(SCREEN2_A+1),A

		LD	BC,$0607	;LEE POR PARTES LA PAGINA 10
		LD	DE,6912		;(DEL ARCHIVO) EN LAS ZONAS QUE SE
		LD	HL,$C000	;PUEDEN USAR SIN PELIGRO DE LA PAGINA
		CALL	READ		;7 (C000h - DAFFh)
		JR	NC,SAFE_ZONA

		LD	BC,$0607	;(E500h - E5FFh)
		LD	DE,256
		LD	HL,$E500
		CALL	READ
		JR	NC,SAFE_ZONA

		LD	BC,$0607	;(E610h - FFFFh)
		LD	DE,6640
		LD	HL,$E610
		CALL	READ
		JR	NC,SAFE_ZONA

		LD	BC,$0607	;SI LAS ZONAS ANTERIORES NO FUERON
		LD	DE,2576		;SUFICIENTES ENTONCES SE HECHA MANO
		LD	HL,$4801	;DE (4801h - 5210h) EN PAGINA 5
		CALL	READ

SAFE_ZONA:	CALL	DD_L_OFFMOTOR	;APAGA EL MOTOR DEL DRIVE :-)

		LD	HL,$E500	;JUNTA TODOS LOS PEDAZOS DE LA PAGINA7
		LD	DE,$DB00	;A PARTIR DE AHORA NO SE USA MAS +3DOS
		LD	BC,256
		LDIR
		LD	HL,$E610
		LD	BC,6640
		LDIR
		LD	HL,$4801
		LD	BC,2576
		LDIR

		LD	HL,(P7_TAM)	;Y SE DESCOMPRIME
		LD	(COUNT),HL
		LD	HL,$C000
		LD	(CPOS),HL
		CALL	UNP_PAG2

		LD	HL,AY_REGS	;SE LEEN LOS REGISTROS DEL AY-3-8912
		XOR	A		;RECUPERADOS POR "READ_REG"
LSET_REG_AY:	PUSH	AF
		LD	BC,$FFFD
		OUT	(C),A
		LD	BC,$BFFD
		LD	A,(HL)
		OUT	(C),A
		POP	AF
		INC	HL
		INC	A
		CP	16
		JR	NZ,LSET_REG_AY
		LD	BC,$FFFD
		LD	A,(LAST_FFFD)
		OUT	(C),A

		LD	HL,BUFF_IMP	;RECUPERA 5B00h - 5BFFh
		LD	DE,$5B00
		LD	BC,256
		LDIR

		LD	BC,PBANK678	;SE PONE EL PORT 1FFD A SU
		LD	A,(LAST_1FFD)	;VALOR ESTANDAR O EL INDICADO
		OUT	(C),A		;POR EL Z80

		LD	BC,PBANKM
		LD	A,(LAST_7FFD)
		OUT	(C),A

		CALL	POKEAR		;SE POKEA EL JUEGO
		CALL	SET_REG		;SE CARGAN LOS REGISTROS

		LD	A,(MULTIFACE3)
		AND	A
		JR	Z,BOOT_SIN_MF3

		IN_MF3
		LD	HL,$B0ED	;LDIR
		LD	($4000),HL
		LD	HL,$BFDB	;IN A,(BFh)
		LD	($2000+2),HL
		LD	HL,BOOT128K	;SE COPIA EN 2000h DE LA RAM DEL MF3
		LD	DE,$2000+4	;EL BOOTSTRAP POR QUE SI NO AL HACER
		LD	BC,RPC-BOOT128K+3;EL LDIR EL PROGRAMA SE PERDERIA
		LDIR
		LD	HL,$2002
		LD	DE,$4002
		LD	BC,6912-2
		LD	SP,(RSP)
		JP	16384

BOOT_SIN_MF3:	LD	SP,(RSP)
		JP	BOOT128K	;SE LANZA EL JUEGO

		.TEXT	"END"

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		.ORG	BOOTEADOR ;!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

; ==========================================================================
; COMIENZA LA CARGA DE UN SNAP 48K
; ==========================================================================
;
; ESTA RUTINA SUFRIO LA MODIFICACION DE SELECCIONAR QUE PAGINA SE
; CARGA Y EN DONDE... ES DECIR, LAS VA COLOCANDO DEPENDIENDO DEL NRO.
; DE ID DE PAGINA QUE VAYA ENTRANDO, PORQUE DIFERENTES EMULADORES
; LAS ALMACENAN EN DISTINTO ORDEN

DIF_48K:	.TEXT	"SNAP48K"

SNAP48K:	CALL	READ_REG	;SE CARGAN LOS VALORES DE LOS
					;REGISTROS
		CALL	GO_FIRSTPAG
		LD	B,$03		;3*16k de paginas (49152 bytes RAM)
BUCL_48K:	PUSH	BC
		CALL	GET_TAMPAG
		CP	$05		;PAGINA FISICA 5 (PANTALLA)
		JR	Z,DESC_SCREEN
		CP	$01		;PAGINA FISICA 2 ($8000-$BFFF)
		JR	Z,DESC_8000
		CP	$02		;PAGINA FISICA 0 ($C000-$FFFF)
		JR	Z,DESC_C000
		JP	ERRSNAP

DESC_8000:	LD	A,$02		;SE CARGA EN PAGINA 2 DE RAM
		CALL	UNP_PAG
		JR	NEXT_L48K

DESC_C000:	XOR	A		;SE CARGA EN PAGINA 0 DE RAM
		CALL	UNP_PAG
		JR	NEXT_L48K

DESC_SCREEN:	LD	A,$06		;PAGINA 5 (PERO LA PONE DE MOMENTO
		CALL	UNP_PAG		;EN LA 6 YA QUE EN LA 5 ESTA ESTE
NEXT_L48K:	POP	BC		;PROGRAMA TODAVIA)
		DJNZ	BUCL_48K

FIN_LOAD48K:	DI
		LD	A,$06
		LD	BC,PBANKM
		OUT	(C),A
		LD	HL,$DB00	;SE RECUPERA DESDE 5C00h A 7FFFh
		LD	DE,$5B00	;EN PAGINA 5
		LD	BC,16384-6912
		LDIR
		XOR	A
		LD	BC,PBANKM
		OUT	(C),A

		CALL	POKEAR		;SE POKEA EL JUEGO 23296 a 65535

		LD	A,$06		;SE COPIA EN C000h DE PAGINA 6
		LD	BC,PBANKM	;EL BOOTSTRAP POR QUE SI NO AL
		OUT	(C),A		;HACER EL LDIR EN BOOT48K EL PROGRAMA
		LD	HL,BOOT48K	;SE PERDERIA
		LD	DE,$C000
		LD	BC,RPC-BOOT48K+3
		LDIR

		CALL	SET_REG		;SE CARGAN LOS REGISTROS

		LD	A,(IM_MODE)	;ESTE ES UN ARREGLO ESPECIAL SOLO PARA
		CP	$5E		;LANZAR JUEGOS DE 48K EN EL PLUS3
		JR	NZ,REG_INT_OK	;CUANDO EL REGISTRO I TIENE UN VALOR
		LD	A,(RINT+1)	;MENOR A 40h SE LE DA EL VALOR 3Bh
		CP	$40		;PORQUE (3BFFh)=FFFFh (esta es una
		JR	NC,REG_INT_OK	;fuente de muchas incompatibilidades
		LD	A,$3B		;de juegos 48K en el +3)
		LD	I,A

REG_INT_OK:	LD	SP,(RSP)
		LD	A,%00000100
		LD	BC,$1FFD
		OUT	(C),A
		LD	HL,$C000
		LD	DE,$4000
		LD	BC,$1B00
REG_LATCH:	LD	A,$00
		JP	BOOT48K		;SE LANZA EL JUEGO (HL, DE, BC)
					;YA LLEVAN LOS VALORES ADECUADOS PARA
					;EL LDIR EN BOOT48K, Y EL REGISTRO A
					;LLEVA EL VALOR A PONER EN EL PUERTO
					;7FFD (USUALMENTE 30H) PERO PUEDE SER
					;TAMBIEN 10H (VER ETIQUETA USR0)


REG_PAGINA:	.EQU	REG_LATCH-DIF_48K

		.DB	"END",$00

		.DB	"(L) 1999 DJr - V1.11",$FF	; revisado 10/2012
		.END
